apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ minio_name }}
  name: {{ minio_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ minio_replicas }}
  selector:
    matchLabels:
      name: {{ minio_name }}
  serviceName: {{ minio_name }}
  template:
    metadata:
      labels:
        name: {{ minio_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ minio_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ minio_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - command:
        - /bin/sh
        - -ce
        - /usr/bin/docker-entrypoint.sh minio server http://{{ minio_name }}-{{ '{' }}0...{{ (minio_replicas | int) - 1 }}{{'}'}}.{{ minio_name }}.{{ namespace }}.svc.{{ cluster_domain }}/data{0...{{ (minio_drives_per_replica | int) - 1 }}{{ '}' }}
        env:
        - name: MINIO_BROWSER
{% if do_debugs or minio_do_browser %}
          value: "on"
{% else %}
          value: "off"
{% endif %}
        - name: MINIO_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name }}-admin
{% if 0 == 1 %}
## WARNING:
## setting those to an empty value would make minio crash / input sanitation
## to automate keys rotation, we can't set the value to "" -- forcing k8s apply/patch/merge to remove spurious env vars
## thus, we'll probably have to delete/recreate the statefulset.
## ... if I ever implement keys rotation...
        - name: MINIO_ACCESS_KEY_OLD
          value: old-access-key-ref
{% endif %}
        - name: MINIO_API_READY_DEADLINE
          value: {{ minio_ready_deadline_seconds }}s
{% if do_ldap %}
        - name: MINIO_IDENTITY_LDAP_COMMENT
          value: Opsperator LDAP {{ ldap_namespace }}/{{ ldap_name }}
        - name: MINIO_IDENTITY_LDAP_LOOKUP_BIND_DN
          value: cn=minio,ou=services,{{ ldap_directory_root }}
        - name: MINIO_IDENTITY_LDAP_LOOKUP_BIND_PASSWORD
          valueFrom:
            secretKeyRef:
              key: minio-password
              name: {{ ldap_secret_name }}
        - name: MINIO_IDENTITY_LDAP_GROUP_SEARCH_BASE_DN
          value: ou=groups,{{ ldap_directory_root }}
        - name: MINIO_IDENTITY_LDAP_GROUP_SEARCH_FILTER
          value: "(|(objectClass=groupOfNames)(objectClass=groupOfURLs))"
        - name: MINIO_IDENTITY_LDAP_SERVER_ADDR
{% if ldaps_address | default(False) %}
          value: "{{ ldaps_address | urlsplit('hostname') }}:{{ ldaps_address | urlsplit('port') }}"
{% else %}
          value: "{{ ldap_address | urlsplit('hostname') }}:{{ ldap_address | urlsplit('port') }}"
{% endif %}
        - name: MINIO_IDENTITY_LDAP_SERVER_INSECURE
          value: "o{{ 'ff' if (ldaps_address | default(False)) else 'n' }}"
        - name: MINIO_IDENTITY_LDAP_SERVER_STARTTLS
          value: "off"
        - name: MINIO_IDENTITY_LDAP_TLS_SKIP_VERIFY
          value: "on"
        - name: MINIO_IDENTITY_LDAP_USER_DN_SEARCH_BASE_DN
          value: ou=users,{{ ldap_directory_root }}
        - name: MINIO_IDENTITY_LDAP_USER_DN_SEARCH_FILTER
          value: "(&(objectClass={{ useroc }})(!(pwdAccountLockedTime=*)))"
        - name: MINIO_IDENTITY_LDAP_USERNAME_FORMAT
          value: uid=%s,ou=users,{{ ldap_directory_root }}
{% endif %}
        - name: MINIO_REGION_NAME
          value: {{ minio_region }}
        - name: MINIO_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name }}-admin
{% if 0 == 1 %}
        - name: MINIO_SECRET_KEY_OLD
          value: old-secret-key-ref
{% endif %}
{% if do_exporters %}
        - name: MINIO_PROMETHEUS_AUTH_TYPE
          value: public
{% endif %}
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='minio'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 15
          httpGet:
            path: /minio/health/live
            port: 9000
          initialDelaySeconds: 10
          periodSeconds: 30
          timeoutSeconds: {{ (minio_ready_deadline_seconds | int) + 1 }}
        name: minio
        ports:
        - name: http
          containerPort: 9000
        readinessProbe:
          httpGet:
            path: /minio/health/ready
            port: 9000
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: {{ (minio_ready_deadline_seconds | int) + 1 }}
        resources:
          limits:
            cpu: "{{ minio_cpu_limit }}"
            memory: "{{ minio_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ minio_cpu_limit }}"
            memory: "{{ minio_memory_limit }}"
{% else %}
            cpu: "{{ minio_cpu_request }}"
            memory: "{{ minio_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% for n in range(minio_drives_per_replica | int) %}
        - mountPath: /data{{ loop.index0 }}
{% if minio_pvc_single %}
          name: data
          subPath: part{{ loop.index0 }}
{% else %}
          name: data{{ loop.index0 }}
{% endif %}
{% endfor %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ minio_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
{% if minio_pvc_single %}
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ minio_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
{% else %}
{% for n in range(minio_drives_per_replica | int) %}
  - metadata:
      name: data{{ loop.index0 }}
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ minio_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
{% endfor %}
{% endif %}
